import csv
# no other imports allowed for this problem!


def parse_reviews(filename):
    '''
    Reads in the csv file corresponding to the filename and returns a set
    of (item_str, user_str, rating_float, timestamp_int) tuples.

    Each line in the CSV has four columns: item, user, rating, timestamp.

    Arguments:
        filename (string) - name of csv with one order per row. e.g.,
                                "resources/tiny_office_products.csv"

    Outputs:
        A set of unique review tuples.
    '''
    pass # your code here

def make_user_ratings(reviews):
    '''
    Given a set of review tuples, creates mapping between users and a list of
    each user's ratings.

    Inputs:
        reviews: set of (item_str, user_str, rating_float, timestamp_int) tuples

    Returns:
        A dictionary of the form {user_str: [rating1, rating2, ...]}
    '''
    pass # your code here

def make_item_ratings(reviews):
    '''
    Given a set of review tuples, creates mapping between items and a list of
    all that item's ratings.

    Inputs:
        reviews: set of (item_str, user_str, rating_float, timestamp_int) tuples

    Returns:
        A dictionary of the form {item_str: [rating1, rating2, ...]}
    '''
    pass # your code here

def filter5(ratings_map, key):
    """
    Returns whether there are at least 5 reviews associated
    with the given key. Key must exist in the ratings_map.
    """
    pass # your code here

def filter_ratings(ratings_map, filter):
    '''
    Given ratings and a filter function, create a new dictionary that contains
    only key/values that pass the filter.

    Inputs:
        ratings_map: A map between a string and a list of ratings (1.0-5.0)
        filter: A function that takes a ratings_map and a key as input, and
            returns a boolean indicating whether the key passes the filter test.

    Returns:
        A new filtered ratings_map dictionary.
    '''
    pass # your code here

def larger_num_ratings(ratings_map, key1, key2):
    """
    Performs a comparison between two valid keys in the ratings map and
    returns the key with the greater total number of ratings.
    """
    pass # your code here

def find_best(ratings_map, compare):
    '''
    Given ratings and a comparison function, find and return the best key
    in the ratings.

    Inputs:
        ratings_map: A map between a string and a list of ratings (1.0-5.0)
        compare: A function that takes a ratings_map and two valid keys as
            input, returns the better key.

    Returns:
        A string representing the key which compared better than all other
        keys in the ratings.
    '''
    pass # your code here


if __name__ == '__main__':
    # copy and paste the full path to the ratings/resources folder here:
    folder = "resources/"

    medium_reviews = parse_reviews(folder + "medium_office_products.csv")
    small_reviews = parse_reviews(folder + "small_office_products.csv")
    tiny_reviews = parse_reviews(folder + "tiny_office_products.csv")
    ####################################################################
    # Your code below:
